#ifndef INCLUDE_H_EVENTOBJECT
#define INCLUDE_H_EVENTOBJECT

#include <exception>

class EventRef
{
public:
	EventRef( bool v_auto = false, bool v_initialState = false ) throw ( std::exception );
	EventRef( const EventRef& v_event ) throw();
	EventRef& operator=( const EventRef& v_event ) throw();
	~EventRef() throw();

	bool waitForSignal( DWORD v_wait = INFINITE ) throw();
	void signal( bool v_state ) throw();
	void pulse() throw();

private:
	struct EventData_
	{
		HANDLE hEvent_;
		int ref_;
	};

	mutable EventData_* pEventData_;
};

#endif
